> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Create VPC peering

POST https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/vpc-peering
Content-Type: application/json

Create a VPC peering between two VPCs on the same site.

Tenant Admin can create single-tenant peerings (both VPCs belong to their tenant).
Provider Admin can create multi-tenant peerings (VPCs from different tenants).

User must have `FORGE_TENANT_ADMIN` or `FORGE_PROVIDER_ADMIN` role.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/vpc-peering/create-vpc-peering

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/vpc-peering:
    post:
      operationId: create-vpc-peering
      summary: Create VPC peering
      description: >-
        Create a VPC peering between two VPCs on the same site.


        Tenant Admin can create single-tenant peerings (both VPCs belong to
        their tenant).

        Provider Admin can create multi-tenant peerings (VPCs from different
        tenants).


        User must have `FORGE_TENANT_ADMIN` or `FORGE_PROVIDER_ADMIN` role.
      tags:
        - subpackage_vpcPeering
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/VpcPeering'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '404':
          description: Error response when requested object is not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/VpcPeeringCreateRequest'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    VpcPeeringCreateRequest:
      type: object
      properties:
        vpc1Id:
          type: string
          format: uuid
          description: ID of the first VPC in the peering
        vpc2Id:
          type: string
          format: uuid
          description: ID of the second VPC to peer with
        siteId:
          type: string
          format: uuid
          description: ID of the Site where the peering exists
      required:
        - vpc1Id
        - vpc2Id
        - siteId
      description: >-
        Request data to create a VPC peering between two VPCs, the ordering of
        VPCs is not important
      title: VpcPeeringCreateRequest
    VpcPeeringStatus:
      type: string
      enum:
        - Pending
        - Configuring
        - Requested
        - Ready
        - Deleting
        - Error
      description: Status values for VPC peering objects
      title: VpcPeeringStatus
    VpcPeering:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier of the VPC peering
        vpc1Id:
          type: string
          format: uuid
          description: ID of the first VPC in the peering
        vpc2Id:
          type: string
          format: uuid
          description: ID of the second VPC in the peering
        siteId:
          type: string
          format: uuid
          description: ID of the Site where the peering exists
        isMultiTenant:
          type: boolean
          description: >-
            Indicates if this is a multi-tenant peering (VPCs from different
            tenants)
        status:
          $ref: '#/components/schemas/VpcPeeringStatus'
          description: Status of the VPC peering
        created:
          type: string
          format: date-time
          description: Date and time when the VPC peering was created
        updated:
          type: string
          format: date-time
          description: Date and time when the VPC peering was last updated
      description: VPC peering connection between two VPCs on the same site
      title: VpcPeering
    CarbideApiErrorSource:
      type: string
      enum:
        - carbide
      description: Source of the error. Only 'carbide' is supported
      title: CarbideApiErrorSource
    CarbideApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: CarbideApiErrorData
    CarbideAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/CarbideApiErrorSource'
          description: Source of the error. Only 'carbide' is supported
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/CarbideApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NCX Infra Controller REST API
      title: CarbideAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-peering"

payload = {
    "vpc1Id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "vpc2Id": "34f5c98e-f430-457b-a812-92637d0c6fd0",
    "siteId": "72771e6a-6f5e-4de4-a5b9-1266c4197811"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-peering';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"vpc1Id":"497f6eca-6276-4993-bfeb-53cbbbba6f08","vpc2Id":"34f5c98e-f430-457b-a812-92637d0c6fd0","siteId":"72771e6a-6f5e-4de4-a5b9-1266c4197811"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-peering"

	payload := strings.NewReader("{\n  \"vpc1Id\": \"497f6eca-6276-4993-bfeb-53cbbbba6f08\",\n  \"vpc2Id\": \"34f5c98e-f430-457b-a812-92637d0c6fd0\",\n  \"siteId\": \"72771e6a-6f5e-4de4-a5b9-1266c4197811\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-peering")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"vpc1Id\": \"497f6eca-6276-4993-bfeb-53cbbbba6f08\",\n  \"vpc2Id\": \"34f5c98e-f430-457b-a812-92637d0c6fd0\",\n  \"siteId\": \"72771e6a-6f5e-4de4-a5b9-1266c4197811\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-peering")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"vpc1Id\": \"497f6eca-6276-4993-bfeb-53cbbbba6f08\",\n  \"vpc2Id\": \"34f5c98e-f430-457b-a812-92637d0c6fd0\",\n  \"siteId\": \"72771e6a-6f5e-4de4-a5b9-1266c4197811\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-peering', [
  'body' => '{
  "vpc1Id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "vpc2Id": "34f5c98e-f430-457b-a812-92637d0c6fd0",
  "siteId": "72771e6a-6f5e-4de4-a5b9-1266c4197811"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-peering");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"vpc1Id\": \"497f6eca-6276-4993-bfeb-53cbbbba6f08\",\n  \"vpc2Id\": \"34f5c98e-f430-457b-a812-92637d0c6fd0\",\n  \"siteId\": \"72771e6a-6f5e-4de4-a5b9-1266c4197811\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "vpc1Id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "vpc2Id": "34f5c98e-f430-457b-a812-92637d0c6fd0",
  "siteId": "72771e6a-6f5e-4de4-a5b9-1266c4197811"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-peering")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```